//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private VolumeLevelsTE[] cacheVolumeLevelsTE = null;

        private static VolumeLevelsTE checkVolumeLevelsTE = new VolumeLevelsTE();

        /// <summary>
        /// Volume Levels (trading-evolution.com)
        /// </summary>
        /// <returns></returns>
        public VolumeLevelsTE VolumeLevelsTE(bool bl_ray_contract, bool bl_ray_day, bool bl_ray_prev_day, bool bl_ray_prev_week, bool bl_ray_week, Color clr_contract, Color clr_contract_base, Color clr_day, Color clr_day_base, Color clr_prev_day, Color clr_prev_day_base, Color clr_prev_week, Color clr_prev_week_base, Color clr_week, Color clr_week_base, int contr_length, int contr_offset, int contr_volume, int contract_width, int day_length, int day_volume, int day_width, int prev_day_length, int prev_day_volume, int prev_day_width, int prev_week_length, int prev_week_volume, int prev_week_width, int week_length, int week_volume, int week_width)
        {
            return VolumeLevelsTE(Input, bl_ray_contract, bl_ray_day, bl_ray_prev_day, bl_ray_prev_week, bl_ray_week, clr_contract, clr_contract_base, clr_day, clr_day_base, clr_prev_day, clr_prev_day_base, clr_prev_week, clr_prev_week_base, clr_week, clr_week_base, contr_length, contr_offset, contr_volume, contract_width, day_length, day_volume, day_width, prev_day_length, prev_day_volume, prev_day_width, prev_week_length, prev_week_volume, prev_week_width, week_length, week_volume, week_width);
        }

        /// <summary>
        /// Volume Levels (trading-evolution.com)
        /// </summary>
        /// <returns></returns>
        public VolumeLevelsTE VolumeLevelsTE(Data.IDataSeries input, bool bl_ray_contract, bool bl_ray_day, bool bl_ray_prev_day, bool bl_ray_prev_week, bool bl_ray_week, Color clr_contract, Color clr_contract_base, Color clr_day, Color clr_day_base, Color clr_prev_day, Color clr_prev_day_base, Color clr_prev_week, Color clr_prev_week_base, Color clr_week, Color clr_week_base, int contr_length, int contr_offset, int contr_volume, int contract_width, int day_length, int day_volume, int day_width, int prev_day_length, int prev_day_volume, int prev_day_width, int prev_week_length, int prev_week_volume, int prev_week_width, int week_length, int week_volume, int week_width)
        {
            if (cacheVolumeLevelsTE != null)
                for (int idx = 0; idx < cacheVolumeLevelsTE.Length; idx++)
                    if (cacheVolumeLevelsTE[idx].Bl_ray_contract == bl_ray_contract && cacheVolumeLevelsTE[idx].Bl_ray_day == bl_ray_day && cacheVolumeLevelsTE[idx].Bl_ray_prev_day == bl_ray_prev_day && cacheVolumeLevelsTE[idx].Bl_ray_prev_week == bl_ray_prev_week && cacheVolumeLevelsTE[idx].Bl_ray_week == bl_ray_week && cacheVolumeLevelsTE[idx].Clr_contract == clr_contract && cacheVolumeLevelsTE[idx].Clr_contract_base == clr_contract_base && cacheVolumeLevelsTE[idx].Clr_day == clr_day && cacheVolumeLevelsTE[idx].Clr_day_base == clr_day_base && cacheVolumeLevelsTE[idx].Clr_prev_day == clr_prev_day && cacheVolumeLevelsTE[idx].Clr_prev_day_base == clr_prev_day_base && cacheVolumeLevelsTE[idx].Clr_prev_week == clr_prev_week && cacheVolumeLevelsTE[idx].Clr_prev_week_base == clr_prev_week_base && cacheVolumeLevelsTE[idx].Clr_week == clr_week && cacheVolumeLevelsTE[idx].Clr_week_base == clr_week_base && cacheVolumeLevelsTE[idx].Contr_length == contr_length && cacheVolumeLevelsTE[idx].Contr_offset == contr_offset && cacheVolumeLevelsTE[idx].Contr_volume == contr_volume && cacheVolumeLevelsTE[idx].Contract_width == contract_width && cacheVolumeLevelsTE[idx].Day_length == day_length && cacheVolumeLevelsTE[idx].Day_volume == day_volume && cacheVolumeLevelsTE[idx].Day_width == day_width && cacheVolumeLevelsTE[idx].Prev_day_length == prev_day_length && cacheVolumeLevelsTE[idx].Prev_day_volume == prev_day_volume && cacheVolumeLevelsTE[idx].Prev_day_width == prev_day_width && cacheVolumeLevelsTE[idx].Prev_week_length == prev_week_length && cacheVolumeLevelsTE[idx].Prev_week_volume == prev_week_volume && cacheVolumeLevelsTE[idx].Prev_week_width == prev_week_width && cacheVolumeLevelsTE[idx].Week_length == week_length && cacheVolumeLevelsTE[idx].Week_volume == week_volume && cacheVolumeLevelsTE[idx].Week_width == week_width && cacheVolumeLevelsTE[idx].EqualsInput(input))
                        return cacheVolumeLevelsTE[idx];

            lock (checkVolumeLevelsTE)
            {
                checkVolumeLevelsTE.Bl_ray_contract = bl_ray_contract;
                bl_ray_contract = checkVolumeLevelsTE.Bl_ray_contract;
                checkVolumeLevelsTE.Bl_ray_day = bl_ray_day;
                bl_ray_day = checkVolumeLevelsTE.Bl_ray_day;
                checkVolumeLevelsTE.Bl_ray_prev_day = bl_ray_prev_day;
                bl_ray_prev_day = checkVolumeLevelsTE.Bl_ray_prev_day;
                checkVolumeLevelsTE.Bl_ray_prev_week = bl_ray_prev_week;
                bl_ray_prev_week = checkVolumeLevelsTE.Bl_ray_prev_week;
                checkVolumeLevelsTE.Bl_ray_week = bl_ray_week;
                bl_ray_week = checkVolumeLevelsTE.Bl_ray_week;
                checkVolumeLevelsTE.Clr_contract = clr_contract;
                clr_contract = checkVolumeLevelsTE.Clr_contract;
                checkVolumeLevelsTE.Clr_contract_base = clr_contract_base;
                clr_contract_base = checkVolumeLevelsTE.Clr_contract_base;
                checkVolumeLevelsTE.Clr_day = clr_day;
                clr_day = checkVolumeLevelsTE.Clr_day;
                checkVolumeLevelsTE.Clr_day_base = clr_day_base;
                clr_day_base = checkVolumeLevelsTE.Clr_day_base;
                checkVolumeLevelsTE.Clr_prev_day = clr_prev_day;
                clr_prev_day = checkVolumeLevelsTE.Clr_prev_day;
                checkVolumeLevelsTE.Clr_prev_day_base = clr_prev_day_base;
                clr_prev_day_base = checkVolumeLevelsTE.Clr_prev_day_base;
                checkVolumeLevelsTE.Clr_prev_week = clr_prev_week;
                clr_prev_week = checkVolumeLevelsTE.Clr_prev_week;
                checkVolumeLevelsTE.Clr_prev_week_base = clr_prev_week_base;
                clr_prev_week_base = checkVolumeLevelsTE.Clr_prev_week_base;
                checkVolumeLevelsTE.Clr_week = clr_week;
                clr_week = checkVolumeLevelsTE.Clr_week;
                checkVolumeLevelsTE.Clr_week_base = clr_week_base;
                clr_week_base = checkVolumeLevelsTE.Clr_week_base;
                checkVolumeLevelsTE.Contr_length = contr_length;
                contr_length = checkVolumeLevelsTE.Contr_length;
                checkVolumeLevelsTE.Contr_offset = contr_offset;
                contr_offset = checkVolumeLevelsTE.Contr_offset;
                checkVolumeLevelsTE.Contr_volume = contr_volume;
                contr_volume = checkVolumeLevelsTE.Contr_volume;
                checkVolumeLevelsTE.Contract_width = contract_width;
                contract_width = checkVolumeLevelsTE.Contract_width;
                checkVolumeLevelsTE.Day_length = day_length;
                day_length = checkVolumeLevelsTE.Day_length;
                checkVolumeLevelsTE.Day_volume = day_volume;
                day_volume = checkVolumeLevelsTE.Day_volume;
                checkVolumeLevelsTE.Day_width = day_width;
                day_width = checkVolumeLevelsTE.Day_width;
                checkVolumeLevelsTE.Prev_day_length = prev_day_length;
                prev_day_length = checkVolumeLevelsTE.Prev_day_length;
                checkVolumeLevelsTE.Prev_day_volume = prev_day_volume;
                prev_day_volume = checkVolumeLevelsTE.Prev_day_volume;
                checkVolumeLevelsTE.Prev_day_width = prev_day_width;
                prev_day_width = checkVolumeLevelsTE.Prev_day_width;
                checkVolumeLevelsTE.Prev_week_length = prev_week_length;
                prev_week_length = checkVolumeLevelsTE.Prev_week_length;
                checkVolumeLevelsTE.Prev_week_volume = prev_week_volume;
                prev_week_volume = checkVolumeLevelsTE.Prev_week_volume;
                checkVolumeLevelsTE.Prev_week_width = prev_week_width;
                prev_week_width = checkVolumeLevelsTE.Prev_week_width;
                checkVolumeLevelsTE.Week_length = week_length;
                week_length = checkVolumeLevelsTE.Week_length;
                checkVolumeLevelsTE.Week_volume = week_volume;
                week_volume = checkVolumeLevelsTE.Week_volume;
                checkVolumeLevelsTE.Week_width = week_width;
                week_width = checkVolumeLevelsTE.Week_width;

                if (cacheVolumeLevelsTE != null)
                    for (int idx = 0; idx < cacheVolumeLevelsTE.Length; idx++)
                        if (cacheVolumeLevelsTE[idx].Bl_ray_contract == bl_ray_contract && cacheVolumeLevelsTE[idx].Bl_ray_day == bl_ray_day && cacheVolumeLevelsTE[idx].Bl_ray_prev_day == bl_ray_prev_day && cacheVolumeLevelsTE[idx].Bl_ray_prev_week == bl_ray_prev_week && cacheVolumeLevelsTE[idx].Bl_ray_week == bl_ray_week && cacheVolumeLevelsTE[idx].Clr_contract == clr_contract && cacheVolumeLevelsTE[idx].Clr_contract_base == clr_contract_base && cacheVolumeLevelsTE[idx].Clr_day == clr_day && cacheVolumeLevelsTE[idx].Clr_day_base == clr_day_base && cacheVolumeLevelsTE[idx].Clr_prev_day == clr_prev_day && cacheVolumeLevelsTE[idx].Clr_prev_day_base == clr_prev_day_base && cacheVolumeLevelsTE[idx].Clr_prev_week == clr_prev_week && cacheVolumeLevelsTE[idx].Clr_prev_week_base == clr_prev_week_base && cacheVolumeLevelsTE[idx].Clr_week == clr_week && cacheVolumeLevelsTE[idx].Clr_week_base == clr_week_base && cacheVolumeLevelsTE[idx].Contr_length == contr_length && cacheVolumeLevelsTE[idx].Contr_offset == contr_offset && cacheVolumeLevelsTE[idx].Contr_volume == contr_volume && cacheVolumeLevelsTE[idx].Contract_width == contract_width && cacheVolumeLevelsTE[idx].Day_length == day_length && cacheVolumeLevelsTE[idx].Day_volume == day_volume && cacheVolumeLevelsTE[idx].Day_width == day_width && cacheVolumeLevelsTE[idx].Prev_day_length == prev_day_length && cacheVolumeLevelsTE[idx].Prev_day_volume == prev_day_volume && cacheVolumeLevelsTE[idx].Prev_day_width == prev_day_width && cacheVolumeLevelsTE[idx].Prev_week_length == prev_week_length && cacheVolumeLevelsTE[idx].Prev_week_volume == prev_week_volume && cacheVolumeLevelsTE[idx].Prev_week_width == prev_week_width && cacheVolumeLevelsTE[idx].Week_length == week_length && cacheVolumeLevelsTE[idx].Week_volume == week_volume && cacheVolumeLevelsTE[idx].Week_width == week_width && cacheVolumeLevelsTE[idx].EqualsInput(input))
                            return cacheVolumeLevelsTE[idx];

                VolumeLevelsTE indicator = new VolumeLevelsTE();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Bl_ray_contract = bl_ray_contract;
                indicator.Bl_ray_day = bl_ray_day;
                indicator.Bl_ray_prev_day = bl_ray_prev_day;
                indicator.Bl_ray_prev_week = bl_ray_prev_week;
                indicator.Bl_ray_week = bl_ray_week;
                indicator.Clr_contract = clr_contract;
                indicator.Clr_contract_base = clr_contract_base;
                indicator.Clr_day = clr_day;
                indicator.Clr_day_base = clr_day_base;
                indicator.Clr_prev_day = clr_prev_day;
                indicator.Clr_prev_day_base = clr_prev_day_base;
                indicator.Clr_prev_week = clr_prev_week;
                indicator.Clr_prev_week_base = clr_prev_week_base;
                indicator.Clr_week = clr_week;
                indicator.Clr_week_base = clr_week_base;
                indicator.Contr_length = contr_length;
                indicator.Contr_offset = contr_offset;
                indicator.Contr_volume = contr_volume;
                indicator.Contract_width = contract_width;
                indicator.Day_length = day_length;
                indicator.Day_volume = day_volume;
                indicator.Day_width = day_width;
                indicator.Prev_day_length = prev_day_length;
                indicator.Prev_day_volume = prev_day_volume;
                indicator.Prev_day_width = prev_day_width;
                indicator.Prev_week_length = prev_week_length;
                indicator.Prev_week_volume = prev_week_volume;
                indicator.Prev_week_width = prev_week_width;
                indicator.Week_length = week_length;
                indicator.Week_volume = week_volume;
                indicator.Week_width = week_width;
                Indicators.Add(indicator);
                indicator.SetUp();

                VolumeLevelsTE[] tmp = new VolumeLevelsTE[cacheVolumeLevelsTE == null ? 1 : cacheVolumeLevelsTE.Length + 1];
                if (cacheVolumeLevelsTE != null)
                    cacheVolumeLevelsTE.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheVolumeLevelsTE = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Volume Levels (trading-evolution.com)
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.VolumeLevelsTE VolumeLevelsTE(bool bl_ray_contract, bool bl_ray_day, bool bl_ray_prev_day, bool bl_ray_prev_week, bool bl_ray_week, Color clr_contract, Color clr_contract_base, Color clr_day, Color clr_day_base, Color clr_prev_day, Color clr_prev_day_base, Color clr_prev_week, Color clr_prev_week_base, Color clr_week, Color clr_week_base, int contr_length, int contr_offset, int contr_volume, int contract_width, int day_length, int day_volume, int day_width, int prev_day_length, int prev_day_volume, int prev_day_width, int prev_week_length, int prev_week_volume, int prev_week_width, int week_length, int week_volume, int week_width)
        {
            return _indicator.VolumeLevelsTE(Input, bl_ray_contract, bl_ray_day, bl_ray_prev_day, bl_ray_prev_week, bl_ray_week, clr_contract, clr_contract_base, clr_day, clr_day_base, clr_prev_day, clr_prev_day_base, clr_prev_week, clr_prev_week_base, clr_week, clr_week_base, contr_length, contr_offset, contr_volume, contract_width, day_length, day_volume, day_width, prev_day_length, prev_day_volume, prev_day_width, prev_week_length, prev_week_volume, prev_week_width, week_length, week_volume, week_width);
        }

        /// <summary>
        /// Volume Levels (trading-evolution.com)
        /// </summary>
        /// <returns></returns>
        public Indicator.VolumeLevelsTE VolumeLevelsTE(Data.IDataSeries input, bool bl_ray_contract, bool bl_ray_day, bool bl_ray_prev_day, bool bl_ray_prev_week, bool bl_ray_week, Color clr_contract, Color clr_contract_base, Color clr_day, Color clr_day_base, Color clr_prev_day, Color clr_prev_day_base, Color clr_prev_week, Color clr_prev_week_base, Color clr_week, Color clr_week_base, int contr_length, int contr_offset, int contr_volume, int contract_width, int day_length, int day_volume, int day_width, int prev_day_length, int prev_day_volume, int prev_day_width, int prev_week_length, int prev_week_volume, int prev_week_width, int week_length, int week_volume, int week_width)
        {
            return _indicator.VolumeLevelsTE(input, bl_ray_contract, bl_ray_day, bl_ray_prev_day, bl_ray_prev_week, bl_ray_week, clr_contract, clr_contract_base, clr_day, clr_day_base, clr_prev_day, clr_prev_day_base, clr_prev_week, clr_prev_week_base, clr_week, clr_week_base, contr_length, contr_offset, contr_volume, contract_width, day_length, day_volume, day_width, prev_day_length, prev_day_volume, prev_day_width, prev_week_length, prev_week_volume, prev_week_width, week_length, week_volume, week_width);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Volume Levels (trading-evolution.com)
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.VolumeLevelsTE VolumeLevelsTE(bool bl_ray_contract, bool bl_ray_day, bool bl_ray_prev_day, bool bl_ray_prev_week, bool bl_ray_week, Color clr_contract, Color clr_contract_base, Color clr_day, Color clr_day_base, Color clr_prev_day, Color clr_prev_day_base, Color clr_prev_week, Color clr_prev_week_base, Color clr_week, Color clr_week_base, int contr_length, int contr_offset, int contr_volume, int contract_width, int day_length, int day_volume, int day_width, int prev_day_length, int prev_day_volume, int prev_day_width, int prev_week_length, int prev_week_volume, int prev_week_width, int week_length, int week_volume, int week_width)
        {
            return _indicator.VolumeLevelsTE(Input, bl_ray_contract, bl_ray_day, bl_ray_prev_day, bl_ray_prev_week, bl_ray_week, clr_contract, clr_contract_base, clr_day, clr_day_base, clr_prev_day, clr_prev_day_base, clr_prev_week, clr_prev_week_base, clr_week, clr_week_base, contr_length, contr_offset, contr_volume, contract_width, day_length, day_volume, day_width, prev_day_length, prev_day_volume, prev_day_width, prev_week_length, prev_week_volume, prev_week_width, week_length, week_volume, week_width);
        }

        /// <summary>
        /// Volume Levels (trading-evolution.com)
        /// </summary>
        /// <returns></returns>
        public Indicator.VolumeLevelsTE VolumeLevelsTE(Data.IDataSeries input, bool bl_ray_contract, bool bl_ray_day, bool bl_ray_prev_day, bool bl_ray_prev_week, bool bl_ray_week, Color clr_contract, Color clr_contract_base, Color clr_day, Color clr_day_base, Color clr_prev_day, Color clr_prev_day_base, Color clr_prev_week, Color clr_prev_week_base, Color clr_week, Color clr_week_base, int contr_length, int contr_offset, int contr_volume, int contract_width, int day_length, int day_volume, int day_width, int prev_day_length, int prev_day_volume, int prev_day_width, int prev_week_length, int prev_week_volume, int prev_week_width, int week_length, int week_volume, int week_width)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.VolumeLevelsTE(input, bl_ray_contract, bl_ray_day, bl_ray_prev_day, bl_ray_prev_week, bl_ray_week, clr_contract, clr_contract_base, clr_day, clr_day_base, clr_prev_day, clr_prev_day_base, clr_prev_week, clr_prev_week_base, clr_week, clr_week_base, contr_length, contr_offset, contr_volume, contract_width, day_length, day_volume, day_width, prev_day_length, prev_day_volume, prev_day_width, prev_week_length, prev_week_volume, prev_week_width, week_length, week_volume, week_width);
        }
    }
}
#endregion
